﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Zoo
{
    abstract class Nahrungsmittel
    {
    }

    abstract class Tier : Nahrungsmittel
    {
        string name;
        protected bool istSatt;

        public Tier(string name)
        {
            this.name = name;
        }

        /// <summary>
        /// Versuchen, das Nahrungsmittel zu fressen
        /// </summary>
        /// <param name="futter">Was gefressen werden soll</param>
        /// <returns>Ob das Futter gefressen wurde</returns>
        public abstract bool Friss(Nahrungsmittel futter);

        public abstract bool KannFressen(Nahrungsmittel futter);
    }

    abstract class Pflanze : Nahrungsmittel
    {

    }

    class Maus : Tier
    {
        public Maus (string name)
            : base(name)
        {

        }

        public override bool Friss(Nahrungsmittel futter)
        {
            if(!KannFressen(futter))
            {
                return false;
            }
            istSatt = true;
            return true;
        }

        public override bool KannFressen(Nahrungsmittel futter)
        {
            return futter is Pflanze;
        }
    }

    class Katze : Tier
    {
        int anzahlLeben;

        public Katze(string name, int anzahlLeben)
            : base(name)
        {
            this.anzahlLeben = anzahlLeben;
        }

        public override bool Friss(Nahrungsmittel futter)
        {
            if(!KannFressen(futter))
            {
                return false;
            }
            istSatt = true;
            return true;
        }

        public override bool KannFressen(Nahrungsmittel futter)
        {
            return futter is Maus;
        }
    }

    //class Hund : Tier
    //{

    //}

    //class Kuh : Tier
    //{

    //}

    class Gras : Pflanze
    {

    }
}
